diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/kex.c libssh-wfs/libssh/kex.c
--- libssh-trunk/libssh/kex.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/kex.c	2009-07-07 22:35:57.000000000 -0400
@@ -168,7 +168,15 @@
     char *strings[10];
     int i;
     enter_function();
-    if(packet_wait(session,SSH2_MSG_KEXINIT,1)){
+    int failed = pthread_mutex_lock(&session->packet_mutex);
+    int res;
+    pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->packet_mutex);
+    assert(!failed);
+    res = packet_wait(session,SSH2_MSG_KEXINIT,1);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->packet_mutex);
+    assert(!failed);
+    if(res){
     	leave_function();
     	return -1;
     }
@@ -256,6 +264,10 @@
     int i=0;
     KEX *kex=(server_kex ? &session->server_kex : &session->client_kex);
     enter_function();
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH2_MSG_KEXINIT);
     buffer_add_data(session->out_buffer,kex->cookie,16);
     hashbufout_add_cookie(session);
@@ -270,6 +282,9 @@
     buffer_add_u8(session->out_buffer,0);
     buffer_add_u32(session->out_buffer,0);
     packet_send(session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
     leave_function();
 }
 
@@ -414,7 +429,15 @@
     u16 bits;
     enter_function();
     ssh_log(session,SSH_LOG_PROTOCOL,"Waiting for a SSH_SMSG_PUBLIC_KEY");
-    if(packet_wait(session,SSH_SMSG_PUBLIC_KEY,1)){
+    int failed = pthread_mutex_lock(&session->packet_mutex);
+    int res;
+    pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->packet_mutex);
+    assert(!failed);
+    res = packet_wait(session,SSH_SMSG_PUBLIC_KEY,1);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->packet_mutex);
+    assert(!failed);
+    if(res){
     	leave_function();
         return -1;
     }
@@ -476,6 +499,10 @@
         return -1;
     }
     ssh_log(session,SSH_LOG_PROTOCOL,"sending SSH_CMSG_SESSION_KEY");
+    failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH_CMSG_SESSION_KEY);
     buffer_add_u8(session->out_buffer,SSH_CIPHER_3DES);
     buffer_add_data(session->out_buffer,session->server_kex.cookie,8);
@@ -492,6 +519,9 @@
     buffer_add_u32(session->out_buffer,0);
 
     packet_send(session); 
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
     /* we can set encryption */
     if(crypt_set_algorithms(session)){
     	leave_function();
@@ -500,7 +530,14 @@
     session->current_crypto=session->next_crypto;
     session->next_crypto=NULL;
     ssh_log(session,SSH_LOG_PROTOCOL,"Waiting for a SSH_SMSG_SUCCESS");
-    if(packet_wait(session,SSH_SMSG_SUCCESS,1)){
+    failed = pthread_mutex_lock(&session->packet_mutex);
+    pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->packet_mutex);
+    assert(!failed);
+    res = packet_wait(session,SSH_SMSG_SUCCESS,1);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->packet_mutex);
+    assert(!failed);
+    if(res){
         char buffer[1024];
         snprintf(buffer,sizeof(buffer),"Key exchange failed : %s",ssh_get_error(session));
         ssh_set_error(session,SSH_FATAL,"%s",buffer);
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/log.c libssh-wfs/libssh/log.c
--- libssh-trunk/libssh/log.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/log.c	2009-07-07 22:35:57.000000000 -0400
@@ -55,6 +55,8 @@
 		} else {
 			fprintf(stderr,"[%d] %s\n",verbosity,buffer);
 		}
+		fflush(stderr);
+		__fpurge(stderr);
 	}
 }
 
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/messages.c libssh-wfs/libssh/messages.c
--- libssh-trunk/libssh/messages.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/messages.c	2009-07-07 22:35:57.000000000 -0400
@@ -36,6 +36,11 @@
 #include "libssh/server.h"
 #include "libssh/ssh2.h"
 
+#ifdef HAVE_LIBCRYPTO
+#include <openssl/dsa.h>
+#include <openssl/rsa.h>
+#include <openssl/x509.h>
+#endif
 
 static SSH_MESSAGE *message_new(SSH_SESSION *session){
     SSH_MESSAGE *msg=session->ssh_message;
@@ -61,17 +66,31 @@
     service_c=string_to_char(service);
     ssh_say(2,"Sending a SERVICE_ACCEPT for service %s\n",service_c);
     free(service_c);
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH2_MSG_SERVICE_ACCEPT);
     buffer_add_ssh_string(session->out_buffer,service);
     packet_send(session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
     free(service);
     leave_function();
     return 0;
 }
 
 static void handle_unimplemented(SSH_SESSION *session){
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u32(session->out_buffer,htonl(session->recv_seq-1));
     packet_send(session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
 }
 
 static SSH_MESSAGE *handle_userauth_request(SSH_SESSION *session){
@@ -83,34 +102,218 @@
     enter_function();
     msg=message_new(session);
     msg->type=SSH_AUTH_REQUEST;
+    msg->auth_request.validated = 0;
     msg->auth_request.username=string_to_char(user);
-    free(user);
     service_c=string_to_char(service);
     method_c=string_to_char(method);
-    free(service);
-    free(method);
     ssh_say(2,"auth request for service %s, method %s for user '%s'\n",service_c,method_c,
             msg->auth_request.username);
     free(service_c);
     if(!strcmp(method_c,"none")){
         msg->auth_request.method=SSH_AUTH_NONE;
-        free(method_c);
-        leave_function();
-        return msg;
-    }
-    if(!strcmp(method_c,"password")){
+    } else if(!strcmp(method_c,"password")){
         STRING *pass;
         u8 tmp;
         msg->auth_request.method=SSH_AUTH_PASSWORD;
-        free(method_c);
         buffer_get_u8(session->in_buffer,&tmp);
         pass=buffer_get_ssh_string(session->in_buffer);
         msg->auth_request.password=string_to_char(pass);
         free(pass);
-        leave_function();
-        return msg;
+    } else if(!strcmp(method_c,"publickey")){
+        STRING *algo, *blob;
+        u8 has_sig;
+	char *algo_c;
+
+        msg->auth_request.method=SSH_AUTH_PUBLICKEY;
+        buffer_get_u8(session->in_buffer,&has_sig);
+        algo=buffer_get_ssh_string(session->in_buffer);
+	algo_c = string_to_char(algo);
+
+	if (!strcmp(algo_c,"ssh-dss")) {
+	  msg->auth_request.type = TYPE_DSS;
+	} else if (!strcmp(algo_c,"ssh-rsa")) {
+	  msg->auth_request.type = TYPE_RSA;
+	} else {
+	  msg->auth_request.type = TYPE_UNKNOWN;
+	}
+        blob=buffer_get_ssh_string(session->in_buffer);
+	// Convert to base64
+	BIO *bmem, *b64;
+	BUF_MEM *bptr;
+
+	b64 = BIO_new(BIO_f_base64());
+	BIO_set_flags(b64,BIO_FLAGS_BASE64_NO_NL);
+	bmem = BIO_new(BIO_s_mem());
+	b64 = BIO_push(b64, bmem);
+	BIO_write(b64, string_data(blob), string_len(blob));
+	BIO_flush(b64);
+	BIO_get_mem_ptr(b64, &bptr);
+
+	char *str64 = (char *)malloc(bptr->length+1);
+	memcpy(str64, bptr->data, bptr->length);
+	str64[bptr->length] = 0;
+
+	BIO_free_all(b64);
+	
+        msg->auth_request.password=str64;
+	if (has_sig) {
+	  STRING *sigbufstr = buffer_get_ssh_string(session->in_buffer);
+	  BUFFER *sigbuf = buffer_new();
+	  buffer_add_data(sigbuf, string_data(sigbufstr),
+			  string_len(sigbufstr));
+	  STRING *sigtag = buffer_get_ssh_string(sigbuf);
+	  STRING *sig = buffer_get_ssh_string(sigbuf);
+	  buffer_free(sigbuf);
+	  free(sigbufstr);
+	  char *sigtag_c = string_to_char(sigtag);
+	  if (strcmp(algo_c,sigtag_c)) {
+	    ssh_say(0,"WARNING: Signature tag doesn't match algo: '%s' != '%s'\n",
+		    sigtag_c,algo_c);
+	  }
+	  free(sigtag_c);
+	  free(sigtag);
+	  msg->auth_request.signature = string_to_char(sig);
+	  msg->auth_request.phase = PHASE_PUBLICKEY_SIGNATURE;
+
+	  // Validate signature here
+
+	  // Glue data to validate the signature against
+	  BUFFER *sigdatabuf = buffer_new();
+	  STRING *session_identifier = string_new(SHA_DIGEST_LEN);
+	  string_fill(session_identifier,session->current_crypto->session_id,
+		      SHA_DIGEST_LEN);
+	  buffer_add_ssh_string(sigdatabuf,session_identifier);
+	  free(session_identifier);
+	  buffer_add_u8(sigdatabuf,SSH2_MSG_USERAUTH_REQUEST);
+	  buffer_add_ssh_string(sigdatabuf,user);
+	  buffer_add_ssh_string(sigdatabuf,service);
+	  STRING *tmp = string_from_char("publickey");
+	  buffer_add_ssh_string(sigdatabuf,tmp);
+	  free(tmp);
+	  buffer_add_u8(sigdatabuf,1);
+	  buffer_add_ssh_string(sigdatabuf,algo);
+	  buffer_add_ssh_string(sigdatabuf,blob);
+
+	  unsigned char hash[SHA_DIGEST_LEN+1];
+	  sha1(buffer_get(sigdatabuf),buffer_get_len(sigdatabuf),hash+1);
+	  hash[0] = 0;
+	  buffer_free(sigdatabuf);
+
+#ifdef HAVE_LIBGCRYPT
+#error INCOMPLETE!
+	  gcry_sexp_t s_sig, s_data, s_pubkey;
+	  size_t dummy;
+
+	  gcry_sexp_build(&s_data,&dummy,
+			  "(data (flags pkcs1) (hash sha1 %s))",
+			  data);
+
+	  switch (msg->auth_request.type) {
+	  case TYPE_DSS:
+
+	    gcry_sexp_build(&s_sig,&dummy,
+			    "(sig-val (dsa (r %d) (s %d)))");
+	    gcry_sexp_build(&s_pubkey,&dummy,
+			    "(public-key (dsa (p %d) (q %d) (g %d) (y %d)))");
+	    break;
+	  case TYPE_RSA:
+	  case TYPE_RSA1:
+	    gcry_sexp_build(&s_sig,&dummy,
+			    "(sig-val (rsa (s %d)))");
+	    gcry_sexp_build(&s_pubkey,&dummy,
+			    "(public-key (rsa (n %d) (e %d)))");
+	    break;
+	  default:
+	    goto end_gcrypt; // Leave at default of false
+	  }
+	  msg->auth_request.validated = (gcry_pk_verify(s_sig,
+							s_data,
+							s_pubkey) == 0);
+	end_gcrypt:
+	  gcry_sexp_release(s_sig);
+	  gcry_sexp_release(s_data);
+	  gcry_sexp_release(s_pubkey);
+#elif defined(HAVE_LIBCRYPTO)
+	  unsigned char *pubkeystr = (unsigned char *)string_data(blob);
+	  switch (msg->auth_request.type) {
+	  case TYPE_RSA:
+	  case TYPE_RSA1:
+	    {
+	      BUFFER *rsapkbuf = buffer_new();
+	      buffer_add_data(rsapkbuf, string_data(blob),string_len(blob));
+	      STRING *ssh_rsa = buffer_get_ssh_string(rsapkbuf);
+	      STRING *e = buffer_get_ssh_string(rsapkbuf);
+	      STRING *n = buffer_get_ssh_string(rsapkbuf);
+	      ERR_clear_error();
+	      RSA *pubkey = RSA_new();
+	      if (pubkey != NULL) {
+		pubkey->e = BN_mpi2bn((unsigned char *)e,4+string_len(e),NULL);
+		pubkey->n = BN_mpi2bn((unsigned char *)n,4+string_len(n),NULL);
+	      }
+	      unsigned long err = ERR_get_error();
+	      if (pubkey == NULL || pubkey->e == NULL || pubkey->n == NULL) {
+		ERR_load_crypto_strings();
+		ssh_say(1,"Got a libcrypto error %lu parsing the sent publickey: %s\n",
+			err, ERR_error_string(err,NULL));
+		ERR_clear_error();
+		break;
+	      }
+	      msg->auth_request.validated = 
+		(RSA_verify(NID_sha1, 
+			    hash+1, SHA_DIGEST_LEN,
+			    (unsigned char *)string_data(sig), 
+			    string_len(sig),
+			    pubkey) == 1);
+	      err = ERR_get_error();
+	      if (err != 0) {
+		ERR_load_crypto_strings();
+		ssh_say(1,"Got a libcrypto error %lu validating sig: %s\n",
+			err, ERR_error_string(err,NULL));
+		ERR_clear_error();
+		break;
+	      }
+	      free(ssh_rsa);
+	      free(e);
+	      free(n);
+	      RSA_free(pubkey);
+	      buffer_free(rsapkbuf);
+	    }
+	    break;
+	  case TYPE_DSS:
+	    {
+	      /* This code doesn't work... base it on the RSA code above. */
+	      DSA *pubkey = d2i_DSA_PUBKEY(NULL,
+					   &pubkeystr,
+					   string_len(blob));
+	      if (pubkey == NULL) {
+		break;
+	      }
+	      msg->auth_request.validated = 
+		(DSA_verify(0, buffer_get(sigdatabuf), buffer_get_len(sigdatabuf),
+			    (unsigned char *)msg->auth_request.signature, 
+			    strlen(msg->auth_request.signature),
+			    pubkey) == 1);
+	      DSA_free(pubkey);
+	    }
+	    break;
+	  default:
+	    ;// msg->auth_request.validated = 0; -- default
+	  }
+#endif
+	  free(sig);
+	} else {
+	  msg->auth_request.phase = PHASE_PUBLICKEY_START;
+	}
+	free(algo_c);
+	free(algo);
+        free(blob);
+    } else {
+      msg->auth_request.method=SSH_AUTH_UNKNOWN;
     }
-    msg->auth_request.method=SSH_AUTH_UNKNOWN;
+    // Don't free these until here, because we need them for checking sigs
+    free(user);
+    free(service);
+    free(method);
     free(method_c);
     leave_function();
     return msg;
@@ -124,6 +327,14 @@
     return msg->auth_request.password;
 }
 
+char *ssh_message_auth_publickey(SSH_MESSAGE *msg){
+    return msg->auth_request.password;
+}
+
+int ssh_message_auth_phase(SSH_MESSAGE *msg){
+    return msg->auth_request.phase;
+}
+
 void ssh_message_auth_set_methods(SSH_MESSAGE *msg,int methods){
     msg->session->auth_methods=methods;
 }
@@ -134,6 +345,10 @@
     SSH_SESSION *session=msg->session;
     int ret;
     enter_function();
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH2_MSG_USERAUTH_FAILURE);
     if(session->auth_methods==0){
         session->auth_methods=SSH_AUTH_PUBLICKEY|SSH_AUTH_PASSWORD;
@@ -157,6 +372,9 @@
     else
         buffer_add_u8(session->out_buffer,0); // no partial success
     ret = packet_send(msg->session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
     leave_function();
     return ret;
 }
@@ -164,8 +382,55 @@
 int ssh_message_auth_reply_success(SSH_MESSAGE *msg,int partial){
     if(partial)
         return ssh_message_auth_reply_default(msg,partial);
+    int r;
+    int failed = pthread_mutex_lock(&msg->session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &msg->session->write_mutex);
     buffer_add_u8(msg->session->out_buffer,SSH2_MSG_USERAUTH_SUCCESS);
-    return packet_send(msg->session);
+    r=packet_send(msg->session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&msg->session->write_mutex);
+    assert(!failed);
+    return r;
+}
+
+int ssh_message_auth_reply_request_signature(SSH_MESSAGE *msg) {
+  const char *type_c;
+  SSH_SESSION *session = msg->session;
+  if (msg->auth_request.type == TYPE_DSS) {
+    type_c = "ssh-dss";
+  } else if (msg->auth_request.type == TYPE_RSA
+	     || msg->auth_request.type == TYPE_RSA1) {
+    type_c = "ssh-rsa";
+  } else {
+    // Fail!
+    return ssh_message_auth_reply_default(msg,0);
+  }
+  enter_function();
+
+  ssh_say(2,"Sending a request for a signature\n");
+
+  int ret;
+  int failed = pthread_mutex_lock(&session->write_mutex);
+  assert(!failed);
+  pthread_cleanup_push(&ssh_cleanup_lock,
+		       (void *) &session->write_mutex);
+  buffer_add_u8(session->out_buffer, SSH2_MSG_USERAUTH_PK_OK);
+  
+  STRING *type = string_from_char(type_c);
+  buffer_add_ssh_string(session->out_buffer, type);
+  free(type);
+  STRING *publickey = string_from_char(msg->auth_request.password);
+  buffer_add_ssh_string(session->out_buffer, publickey);
+  free(publickey);
+  
+  ret = packet_send(session);
+  pthread_cleanup_pop(0);
+  failed = pthread_mutex_unlock(&session->write_mutex);
+  assert(!failed);
+  leave_function();
+  return ret;
 }
 
 static SSH_MESSAGE *handle_channel_request_open(SSH_SESSION *session){
@@ -197,6 +462,15 @@
     return msg;
 }
 
+/**
+   Returns 1 if the signature validates, 0 if the signature is invalid,
+   the algorithm is unknown, or msg is not phase PHASE_PUBLICKEY_SIGNATURE,
+   type SSH_AUTH_PUBLICKEY, subtype SSH_AUTH_PUBLICKEY.
+ */
+int ssh_message_auth_validated(SSH_MESSAGE *msg) {
+  return msg->auth_request.validated;
+}
+
 CHANNEL *ssh_message_channel_request_open_reply_accept(SSH_MESSAGE *msg){
 	SSH_SESSION *session=msg->session;
 	enter_function();
@@ -208,13 +482,22 @@
     chan->remote_maxpacket=msg->channel_request_open.packet_size;
     chan->remote_window=msg->channel_request_open.window;
     chan->open=1;
+    int r;
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH2_MSG_CHANNEL_OPEN_CONFIRMATION);
     buffer_add_u32(session->out_buffer,htonl(chan->remote_channel));
     buffer_add_u32(session->out_buffer,htonl(chan->local_channel));
     buffer_add_u32(session->out_buffer,htonl(chan->local_window));
     buffer_add_u32(session->out_buffer,htonl(chan->local_maxpacket));
     ssh_say(2,"Accepting a channel request_open for chan %d\n",chan->remote_channel);
-    if(packet_send(session)){
+    r=packet_send(session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
+    if(r){
         channel_free(chan);
         leave_function();
         return NULL;
@@ -225,12 +508,20 @@
 
 static int ssh_message_channel_request_open_reply_default(SSH_MESSAGE *msg){
     ssh_say(2,"Refusing a channel\n");
+    int r;
+    int failed = pthread_mutex_lock(&msg->session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &msg->session->write_mutex);
     buffer_add_u8(msg->session->out_buffer,SSH2_MSG_CHANNEL_OPEN_FAILURE);
     buffer_add_u32(msg->session->out_buffer,htonl(msg->channel_request_open.sender));
     buffer_add_u32(msg->session->out_buffer,htonl(SSH2_OPEN_ADMINISTRATIVELY_PROHIBITED));
     buffer_add_u32(msg->session->out_buffer,0); // reason is an empty string
     buffer_add_u32(msg->session->out_buffer,0); // language too
-    return packet_send(msg->session);
+    r=packet_send(msg->session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&msg->session->write_mutex);
+    assert(!failed);
 }
 
 static SSH_MESSAGE *handle_channel_request(SSH_SESSION *session){
@@ -315,9 +606,18 @@
     if(msg->channel_request.want_reply){
         channel=msg->channel_request.channel->remote_channel;
         ssh_say(2,"Sending a channel_request success to channel %d\n",channel);
+	int r;
+	int failed = pthread_mutex_lock(&msg->session->write_mutex);
+	assert(!failed);
+	pthread_cleanup_push(&ssh_cleanup_lock,
+			     (void *) &msg->session->write_mutex);
         buffer_add_u8(msg->session->out_buffer,SSH2_MSG_CHANNEL_SUCCESS);
         buffer_add_u32(msg->session->out_buffer,htonl(channel));
-        return packet_send(msg->session);
+        r=packet_send(msg->session);
+	pthread_cleanup_pop(0);
+	failed = pthread_mutex_unlock(&msg->session->write_mutex);
+	assert(!failed);
+	return r;
     } else {
         ssh_say(2,"The client doesn't want to know the request successed\n");
         return 0;
@@ -329,9 +629,18 @@
     if(msg->channel_request.want_reply){
         channel=msg->channel_request.channel->remote_channel;
         ssh_say(2,"Sending a default channel_request denied to channel %d\n",channel);
+	int r;
+	int failed = pthread_mutex_lock(&msg->session->write_mutex);
+	assert(!failed);
+	pthread_cleanup_push(&ssh_cleanup_lock,
+			     (void *) &msg->session->write_mutex);
         buffer_add_u8(msg->session->out_buffer,SSH2_MSG_CHANNEL_FAILURE);
         buffer_add_u32(msg->session->out_buffer,htonl(channel));
-        return packet_send(msg->session);
+        r=packet_send(msg->session);
+	pthread_cleanup_pop(0);
+	failed = pthread_mutex_unlock(&msg->session->write_mutex);
+	assert(!failed);
+	return r;
     } else {
         ssh_say(2,"The client doesn't want to know the request failed ! \n");
         return 0;
@@ -341,16 +650,21 @@
 SSH_MESSAGE *ssh_message_get(SSH_SESSION *session){
 	SSH_MESSAGE *ret;
 	enter_function();
+	
+	int failed = pthread_mutex_lock(&session->packet_mutex);
+	assert(!failed);
+	pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->packet_mutex);
     while(1){
-        if(packet_read(session) || packet_translate(session)){
-        	leave_function();
-        	return NULL;
+      if(packet_read(session) || packet_translate(session)){
+        	ret = NULL;
+		goto exit;
         }
+
         switch(session->in_packet.type){
             case SSH2_MSG_SERVICE_REQUEST:
                 if(handle_service_request(session)){
-                	leave_function();
-                	return NULL;
+                	ret = NULL;
+			goto exit;
                 }
                 break;
             case SSH2_MSG_IGNORE:
@@ -358,25 +672,30 @@
                 break;
             case SSH2_MSG_USERAUTH_REQUEST:
                 ret = handle_userauth_request(session);
-                leave_function();
-                return ret;
+		goto exit;
             case SSH2_MSG_CHANNEL_OPEN:
                 ret = handle_channel_request_open(session);
-                leave_function();
-                return ret;
+		goto exit;
             case SSH2_MSG_CHANNEL_REQUEST:
                 ret = handle_channel_request(session);
-                leave_function();
-                return ret;
+		goto exit;
             default:
                 handle_unimplemented(session);
                 ssh_set_error(session,SSH_FATAL,"Unhandled message %d\n",session->in_packet.type);
-                leave_function();
-                return NULL;
+		ret = NULL;
+		goto exit;
         }
     }
+
+ exit:
+
+    ;
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->packet_mutex);
+    assert(!failed);
+
     leave_function();
-    return NULL;
+    return ret;
 }
 
 int ssh_message_type(SSH_MESSAGE *msg){
@@ -419,8 +738,11 @@
         case SSH_AUTH_REQUEST:
             if(msg->auth_request.username)
                 free(msg->auth_request.username);
+            if(msg->auth_request.signature)
+                free(msg->auth_request.signature);
             if(msg->auth_request.password){
-                memset(msg->auth_request.password,0,strlen(msg->auth_request.password));
+                memset(msg->auth_request.password,0,
+		       strlen(msg->auth_request.password));
                 free(msg->auth_request.password);
             }
             break;
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/misc.c libssh-wfs/libssh/misc.c
--- libssh-trunk/libssh/misc.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/misc.c	2009-07-07 22:35:57.000000000 -0400
@@ -37,18 +37,24 @@
 #endif
 
 #include "libssh/libssh.h"
+#include "libssh/priv.h"
 
 #ifndef _WIN32
 char *ssh_get_user_home_dir(){
     static char szPath[PATH_MAX] = {0};
-    struct passwd *pwd = NULL;
+    struct passwd pwd;
+    struct passwd *res = NULL;
+    int err;
+    int buflen = (long) sysconf(_SC_GETPW_R_SIZE_MAX);
+    char buf[buflen];
 
-    pwd = getpwuid(getuid());
-    if (pwd == NULL) {
+
+    err = getpwuid_r(getuid(), &pwd, buf, buflen, &res);
+    if (err != 0 || res == NULL) {
       return NULL;
     }
 
-    snprintf(szPath, PATH_MAX - 1, "%s", pwd->pw_dir);
+    snprintf(szPath, PATH_MAX - 1, "%s", pwd.pw_dir);
 
     return szPath;
 }
@@ -84,3 +90,26 @@
     return (( ((u64)low) << 32) | ( high));
 #endif
 }
+
+void ssh_cleanup_lock(void *arg) {
+  pthread_mutex_t *l = (pthread_mutex_t *) arg;
+  pthread_mutex_unlock(l);
+}
+
+ssh_mem_list *new_ssh_mem_list() {
+  ssh_mem_list *ml = 
+    (ssh_mem_list *) malloc(sizeof(ssh_mem_list));
+  ml->ptr = NULL;
+  ml->next = NULL;
+  return ml;
+}
+
+void ssh_cleanup_mem(void *arg) {
+  ssh_mem_list *ml = (ssh_mem_list *) arg;
+  while( ml != NULL ) {
+    free(ml->ptr);
+    ssh_mem_list *next = ml->next;
+    free(ml);
+    ml = next;
+  }
+}
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/options.c libssh-wfs/libssh/options.c
--- libssh-trunk/libssh/options.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/options.c	2009-07-07 22:35:58.000000000 -0400
@@ -296,16 +296,20 @@
 
 #ifndef _WIN32
 static char *get_username_from_uid(SSH_OPTIONS *opt, uid_t uid){
-    struct passwd *pwd = NULL;
+    struct passwd pwd;
+    struct passwd *res = NULL;
+    int err;
+    int buflen = (long) sysconf(_SC_GETPW_R_SIZE_MAX);
+    char buf[buflen];
 
-    pwd = getpwuid(uid);
+    err = getpwuid_r(uid, &pwd, buf, buflen, &res);
 
-    if (pwd == NULL) {
+    if (err != 0 || res == NULL) {
       ssh_set_error(opt,SSH_FATAL,"uid %d doesn't exist !",uid);
       return NULL;
     }
 
-    return strdup(pwd->pw_name);
+    return strdup(pwd.pw_name);
 }
 #endif
 
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/packet.c libssh-wfs/libssh/packet.c
--- libssh-trunk/libssh/packet.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/packet.c	2009-07-29 15:04:18.000000000 -0400
@@ -70,7 +70,11 @@
             }
 //    be_read=completeread(session->fd,buffer,blocksize);
             // can't fail since we're sure there is enough data in socket buffer
-            ssh_socket_read(session->socket,buffer,blocksize);
+            ret=ssh_socket_read(session->socket,buffer,blocksize);
+            if(ret != SSH_OK){
+                leave_function();
+            	return ret;
+            }
             len=packet_decrypt_len(session,buffer);
             buffer_add_data(session->in_buffer,buffer,blocksize);
             if(len> MAX_PACKET_LEN){
@@ -96,10 +100,14 @@
                 ret=ssh_socket_wait_for_data(session->socket,session,to_be_read);
                 if(ret!=SSH_OK){
                     leave_function();
-                	return ret;
+		    return ret;
                 }
                 packet=malloc(to_be_read);
-                ssh_socket_read(session->socket,packet,to_be_read-current_macsize);
+                ret=ssh_socket_read(session->socket,packet,to_be_read-current_macsize);
+                if(ret!=SSH_OK){
+                    leave_function();
+		    return ret;
+                }
                 ssh_log(session,SSH_LOG_PACKET,"Read a %d bytes packet",len);
                 buffer_add_data(session->in_buffer,packet,to_be_read-current_macsize);
                 free(packet);
@@ -108,7 +116,11 @@
                 /* decrypt the rest of the packet (blocksize bytes already have been decrypted */
                 packet_decrypt(session,buffer_get(session->in_buffer)+blocksize,
                                buffer_get_len(session->in_buffer)-blocksize);
-                ssh_socket_read(session->socket,mac,macsize);
+                ret=ssh_socket_read(session->socket,mac,macsize);
+                if(ret!=SSH_OK){
+                    leave_function();
+		    return ret;
+                }
                 if(packet_hmac_verify(session,session->in_buffer,mac)){
                     ssh_set_error(session,SSH_FATAL,"HMAC error");
                     leave_function();
@@ -400,12 +412,14 @@
 #endif /* HAVE_SSH1 */
 
 int packet_send(SSH_SESSION *session){
+  int ret;
 #ifdef HAVE_SSH1
     if (session->version==1)
-        return packet_send1(session);
+        ret = packet_send1(session);
     else 
 #endif
-        return packet_send2(session);
+        ret = packet_send2(session);
+    return ret;
 }
 
 void packet_parse(SSH_SESSION *session){
@@ -523,7 +537,7 @@
         ret=packet_read2(session);
         if(ret != SSH_OK){
             leave_function();
-        	return ret;
+	    return ret;
         }
         if(packet_translate(session)){
             leave_function();
@@ -548,15 +562,15 @@
            default:
                if(type && (type != session->in_packet.type)){
                    ssh_set_error(session,SSH_FATAL,"waitpacket(): Received a %d type packet, was waiting for a %d\n",session->in_packet.type,type);
-                   leave_function();
+		   leave_function();
                    return SSH_ERROR;
                }
                leave_function();
-               return SSH_OK;
+	       return SSH_OK;
            }
         if(blocking==0){
             leave_function();
-        	return SSH_OK; //shouldn't it return SSH_AGAIN here ?
+	    return SSH_OK; //shouldn't it return SSH_AGAIN here ?
         }
     }
     leave_function();
